<template>
  <div class="w-full content-center">
    <h1 class="text-3xl m-10">Connexion</h1>

    <div v-if="error" class="error_alert border-l-4 p-2 m-10" role="alert">
      <p class="font-bold">Une erreur est survenue ...</p>
      <br />
      <p>{{ error }}</p>
    </div>

    <form ref="form" :model="form" class="w-full self-center p-5">
      <div class="flex flex-wrap md:items-center mb-6">
        <div class="md:w-1/4">
          <label
            class="block text-white-700 text-sm font-bold mb-2"
            for="email"
            style="float: right;"
          >
            Email
          </label>
        </div>
        <div class="md:w-3/4">
          <input
            class="input_text max-w-sm shadow appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
            prop="email"
            id="email"
            v-model="form.email"
            type="email"
            placeholder="mail@mail.com"
          />
          <p v-if="form_error.email" class="text-red-500 text-sm font-bold m-1">
            Merci de saisir une adresse Email
          </p>
        </div>
      </div>
      <div class="flex flex-wrap md:items-center mb-10">
        <div class="md:w-1/4">
          <label
            class="block text-white-700 text-sm font-bold mb-2"
            for="password"
            style="float: right;"
          >
            Mot de passe
          </label>
        </div>
        <div class="md:w-3/4">
          <input
            class="input_text max-w-sm shadow appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
            prop="password"
            id="password"
            v-model="form.password"
            type="password"
            placeholder="****************"
          />
          <p
            v-if="form_error.password"
            class="text-red-500 text-sm font-bold m-1"
          >
            Merci de saisir un mot de passe
          </p>
        </div>
      </div>
      <div class="flex flex-wrap md:items-center mb-10">
        <br /><br />
        <div class="md:w-1/4"></div>
        <div class="md:w-3/4">
          <button
            class="shadow btn_submit focus:shadow-outline focus:outline-none text-white font-bold py-2 px-4 rounded"
            type="button"
            @click="login()"
          >
            Connexion
          </button>
          <router-link
            :to="{ name: 'register' }"
            class="text-gray-300 hover:bg-gray-700 hover:text-white px-3 py-2 rounded-md text-sm font-medium"
          >
            Inscription
          </router-link>
          <a
            class="font-bold text-sm text-blue-500 hover:text-blue-800 m-10"
            href="#"
          >
            &nbsp;&nbsp;&nbsp;Mot de passe oublié ?
          </a>
        </div>
      </div>
    </form>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      form: {
        email: "",
        password: "",
      },
      form_error: {
        email: false,
        password: false,
      },
      error: false,
    };
  },
  methods: {
    login() {
      const data = this.form;
      this.error = false;

      if (!this.validate(data)) {
        return;
      }

      axios
        .post("http://localhost:8888/photos_api/api/login", data)
        .then((res) => {
          if (res.data.result) {
            localStorage.setItem("token", res.data.token);
            localStorage.setItem("is_logged", true);
            this.$router.push({ name: "home" });
          } else {
            this.error = res.data.error;
          }
        })
        .catch(() => {
          this.error = "Une erreur est survenue";
        });
    },
    validate(data) {
      this.form_error.email = false;
      this.form_error.password = false;

      if (data.email == "") {
        this.form_error.email = true;
        return false;
      } else if (data.password == "") {
        this.form_error.password = true;
        return false;
      }
      return true;
    },
  },
};
</script>
